###################################################
### chunk number 1: 
###################################################
#line 7 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
 options(continue="  ")


###################################################
### chunk number 2: 
###################################################
#line 21 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
library("tsfa") 


###################################################
### chunk number 3: 
###################################################
#line 36 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"

data("CanadianMoneyData.asof.28Jan2005", package="CDNmoney")
data("CanadianCreditData.asof.28Jan2005", package="CDNmoney")

cpi <- 100 * M1total / M1real
seriesNames(cpi) <- "CPI"
popm <- M1total / M1PerCapita
seriesNames(popm) <- "Population of Canada"

z <- tframed(tbind(
    MB2001,
    MB486 + MB452 + MB453 ,
    NonbankCheq,
    MB472 + MB473 + MB487p,
    MB475,
    NonbankNonCheq + MB454 + NonbankTerm + MB2046 + MB2047 + MB2048 +
    MB2057 + MB2058 + MB482),
    names=c("currency", "personal cheq.", "NonbankCheq",
    "N-P demand & notice", "N-P term", "Investment" )
  )


TotalMoney <- tframed(rowSums(z), tframe(z))

z <- tbind (z, ConsumerCredit, ResidentialMortgage,
    ShortTermBusinessCredit, OtherBusinessCredit)


###################################################
### chunk number 4: 
###################################################
#line 67 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
z <-tfwindow(z, start=c(1981,11), end=c(2004,11))

scale <- tfwindow(1e8 /(popm * cpi), tf=tframe(z))

MBandCredit <- sweep(z, 1, scale, "*")


###################################################
### chunk number 5: 
###################################################
#line 79 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(MBandCredit, graphs.per.page=3)


###################################################
### chunk number 6: 
###################################################
#line 83 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(diff(MBandCredit), graphs.per.page=3)


###################################################
### chunk number 7: 
###################################################
#line 89 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
start(MBandCredit)
end(MBandCredit)
Tobs(MBandCredit)
DX <- diff(MBandCredit, lag=1)


###################################################
### chunk number 8: 
###################################################
#line 96 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
Tobs(MBandCredit)


###################################################
### chunk number 9: 
###################################################
#line 100 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
nseries(MBandCredit)


###################################################
### chunk number 10: 
###################################################
#line 104 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
colMeans(DX)


###################################################
### chunk number 11: 
###################################################
#line 108 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
sqrt(diag(cov(DX)))


###################################################
### chunk number 12: 
###################################################
#line 116 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
zz <- eigen(cor(diff(MBandCredit, lag=1)), symmetric=TRUE)[["values"]]
print(zz)


###################################################
### chunk number 13: 
###################################################
#line 121 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
par(omi=c(0.1,0.1,0.1,0.1),mar=c(4.1,4.1,0.6,0.1))
plot(zz, ylab="Value", xlab="Eigenvalue Number", pch=20:20,cex=1,type="o")


###################################################
### chunk number 14: 
###################################################
#line 129 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
z <- FAfitStats(MBandCredit)    
print(z, digits=3)
c2withML <- estTSF.ML(MBandCredit, 2)


###################################################
### chunk number 15: 
###################################################
#line 146 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
z <- matrix(0,10,3)
z[matrix(c( 1,6,2,1:3),3,2)] <- c(10, 56, 41)
c3withML <- estTSF.ML(MBandCredit, 3, BpermuteTarget=z)

z <- matrix(0,10,4)
z[matrix(c( 1,6,2,7,1:4),4,2)] <- c(13, 54, 37, 24)
c4withML  <- estTSF.ML(MBandCredit, 4, BpermuteTarget=z)

z <- matrix(0,10,5)
z[matrix(c( 1,6,2,7,5,1:5),5,2)] <- c(13, 67, 34, 30, 72)
c5withML <- estTSF.ML(MBandCredit, 5, BpermuteTarget=z)


###################################################
### chunk number 16: 
###################################################
#line 162 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
print(DstandardizedLoadings(c4withML) )


###################################################
### chunk number 17: 
###################################################
#line 167 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
print(c4withML$Phi, digits=3)


###################################################
### chunk number 18: 
###################################################
#line 173 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
print(1 - c4withML$stats$uniquenesses)


###################################################
### chunk number 19: 
###################################################
#line 179 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
print(1 - c2withML$stats$uniquenesses)
print(1 - c3withML$stats$uniquenesses)
print(1 - c5withML$stats$uniquenesses)


###################################################
### chunk number 20: 
###################################################
#line 187 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
print(loadings(c4withML) )


###################################################
### chunk number 21: 
###################################################
#line 193 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(factors(c4withML)),
       Title= "Factors from 4 factor model (year-to-year growth rate)",
       lty=c("solid"),
       col=c("black"),
       xlab=c(""),ylab=c("factor 1","factor 2","factor 3","factor 4"),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 22: 
###################################################
#line 205 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(factors(c4withML),
       Title="Factors from 4 factor model",
       lty=c("solid"),
       col=c("black"),
       xlab=c(""),ylab=c("factor 1","factor 2","factor 3","factor 4"),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 23: 
###################################################
#line 219 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"

z <- explained(c4withML)

tfplot(ytoypc(MBandCredit), ytoypc(z), series=1:5, graphs.per.page=5,
       lty=c("solid", "dashed"), 
       col=c("black", "red"),
       ylab=c("currency", "personal cheq.", "NonbankCheq",
              "N-P demand & notice", "N-P term"),
       ylim=list(NULL,NULL,c(-100,100),NULL,NULL),
       Title=
         "Explained money indicator 1-5 (year-to-year growth rate) using 4 factors",
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 24: 
###################################################
#line 237 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(MBandCredit), ytoypc(explained(c4withML)), series=6:10,
       graphs.per.page=5,
       lty=c("solid", "dashed"), 
       col=c("black", "red"),
       ylab=c("","","","","",
              "Investment","Consumer Credit", "Residential Mortgage",
              "Short Term Business Credit", "Other Business Credit"),
       Title=
         "Explained money indicator 6-10 (year-to-year growth rate)using 4 factors",
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 25: 
###################################################
#line 253 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"

tfplot(  MBandCredit,  explained(c4withML),  series=1:5, graphs.per.page=5,
        lty=c("solid", "dashed"), 
        col=c("black", "red"),
        Title= "Explained money indicators 1-5 using 4 factors",
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 26: 
###################################################
#line 265 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(  MBandCredit,  explained(c4withML),  series=6:10, graphs.per.page=5,
        lty=c("solid", "dashed"), 
       col=c("black", "red"),
        Title= "Explained money indicator 6-10 using 4 factors",
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 27: 
###################################################
#line 274 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(  diff(MBandCredit), diff(explained(c4withML)),   graphs.per.page=3)


###################################################
### chunk number 28: 
###################################################
#line 278 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
summary(MBandCredit)


###################################################
### chunk number 29: 
###################################################
#line 287 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
DstandardizedLoadings(c2withML)
print(c2withML$Phi, digits=3)

DstandardizedLoadings(c3withML)
print(c3withML$Phi, digits=3)

print(DstandardizedLoadings(c5withML), digits=3)
print(c5withML$Phi, digits=3)

DstandardizedLoadings(c4withML)
print(c2withML$Phi, digits=3)


###################################################
### chunk number 30: 
###################################################
#line 302 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(factors(c4withML)), ytoypc(factors(c2withML)),
       ytoypc(factors(c3withML)),
       ytoypc(factors(c5withML)), series=1:2,
       xlab=c(""),ylab=c("factor 1","factor 2"),
       lty=c("solid", "dotdash", "dashed", "dotted"),
       col=c("black","green","red","blue"),
       Title= paste("Factors transaction and long ",
        "(year-to-year growth rate) using 2, 3, 4 and 5 factor models", sep=""),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 31: 
###################################################
#line 316 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(factors(c4withML)),
       ytoypc(factors(c3withML)),
       ytoypc(factors(c5withML)), series=3,
       lty=c("solid", "dashed", "dotted"),
       xlab=c(""),ylab=c("","","factor 3"),
       col=c("black","red","blue"),
       Title= paste("Factor near ",
        "(year-to-year growth rate) using 3, 4 and 5 factor models", sep=""),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 32: 
###################################################
#line 335 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
c4withMLg0.5 <- estTSF.ML(MBandCredit, 4, BpermuteTarget=loadings(c4withML),
     rotation="oblimin", rotationArgs=list(gam=0.5))
loadings(c4withMLg0.5)
DstandardizedLoadings(c4withMLg0.5)
DstandardizedLoadings(c4withMLg0.5) - DstandardizedLoadings(c4withML)


###################################################
### chunk number 33: 
###################################################
#line 343 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
summary(c4withMLg0.5)


###################################################
### chunk number 34: 
###################################################
#line 349 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
c4withMLgneg0.5 <- estTSF.ML(MBandCredit, 4, BpermuteTarget=loadings(c4withML),
     rotation="oblimin", rotationArgs=list(gam=-0.5))
loadings(c4withMLgneg0.5)
DstandardizedLoadings(c4withMLgneg0.5)
DstandardizedLoadings(c4withMLgneg0.5) - DstandardizedLoadings(c4withML)
summary(c4withMLgneg0.5)

c4withMLgneg1.0 <- estTSF.ML(MBandCredit, 4, BpermuteTarget=loadings(c4withML),
     rotation="oblimin", rotationArgs=list(gam=-1.0))
loadings(c4withMLgneg1.0)
DstandardizedLoadings(c4withMLgneg1.0)
DstandardizedLoadings(c4withMLgneg1.0) - DstandardizedLoadings(c4withML)
summary(c4withMLgneg1.0)

c4withMLbQ <- estTSF.ML(MBandCredit, 4, rotation="bentlerQ",
     BpermuteTarget=loadings(c4withML))
loadings(c4withMLbQ)
DstandardizedLoadings(c4withMLbQ)
DstandardizedLoadings(c4withMLbQ) - DstandardizedLoadings(c4withML)
summary(c4withMLbQ)


###################################################
### chunk number 35: 
###################################################
#line 374 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(factors(c4withML)), ytoypc(factors(c4withMLg0.5)),
       ytoypc(factors(c4withMLgneg0.5)), ytoypc(factors(c4withMLgneg1.0)),
       ytoypc(factors(c4withMLbQ)),
       xlab=c(""),ylab=c("factor 1","factor 2","factor 3","factor 4"),
       lty=c("solid", "dashed", "dotted", "dotdash", "longdash"),
       col=c("black","red","blue","green","pink"),
       Title= paste(
         "Factors from various 4 factor models (year-to-year growth rate)",
         "\n and oblimin with gam=0 (solid)"),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 36: 
###################################################
#line 393 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
c4withMLgm <- estTSF.ML(MBandCredit, 4, rotation="geominQ",
     BpermuteTarget=loadings(c4withML))
loadings(c4withMLgm)
DstandardizedLoadings(c4withMLgm)


###################################################
### chunk number 37: 
###################################################
#line 400 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
DstandardizedLoadings(c4withMLgm) - DstandardizedLoadings(c4withML)


###################################################
### chunk number 38: 
###################################################
#line 404 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
summary(c4withMLgm)


###################################################
### chunk number 39: 
###################################################
#line 409 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(factors(c4withML)), ytoypc(factors(c4withMLgm)),
       xlab=c(""),ylab=c("factor 1","factor 2","factor 3","factor 4"),
       lty=c("solid", "dashed"),
       col=c("black","red"),
       Title= paste(
     "Factors from geomin (dashed) 4 factor model (year-to-year growth rate)",
     "\n and oblimin with gam=0 (solid)"),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)

c4withMLnotNorm  <- estTSF.ML(MBandCredit, 4, normalize=FALSE,
       BpermuteTarget=loadings(c4withML))



###################################################
### chunk number 40: 
###################################################
#line 427 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
DstandardizedLoadings(c4withML)
DstandardizedLoadings(c4withMLnotNorm)
DstandardizedLoadings(c4withML) - DstandardizedLoadings(c4withMLnotNorm)


###################################################
### chunk number 41: 
###################################################
#line 439 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
z <- matrix(0,10,4)
z[matrix(c( 1,6,2,7,1:4),4,2)] <- c(11, 104, 20, 13)
c4withMLbefore90 <- estTSF.ML(tfwindow(MBandCredit, end=c(1989,12)), 4,
         BpermuteTarget=z)

c4withMLafter95 <- estTSF.ML(tfwindow(MBandCredit, start=c(1995,1)), 4,
         BpermuteTarget=loadings(c4withML))

z <- matrix(0,10,4)
z[matrix(c( 1,6,2,7,1:4),4,2)] <- c(11, 104, 20, 13)
c4withMLbefore95 <- estTSF.ML(tfwindow(MBandCredit, end=c(1994,12)), 4,
         BpermuteTarget=z)

c4withMLafter00 <- estTSF.ML(tfwindow(MBandCredit, start=c(2000,1)), 4,
         BpermuteTarget=loadings(c4withML))

c4withML90to00 <- estTSF.ML(tfwindow(MBandCredit, start=c(1990,1), end=c(2000,1)), 4,
         BpermuteTarget=loadings(c4withML))


###################################################
### chunk number 42: 
###################################################
#line 462 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(factors(c4withML)),         ytoypc(factors(c4withMLbefore90)),
       ytoypc(factors(c4withMLbefore95)), ytoypc(factors(c4withMLafter95)),
       ytoypc(factors(c4withMLafter00)),  ytoypc(factors(c4withML90to00)),
       xlab=c(""),ylab=c("factor 1","factor 2","factor 3","factor 4"),
       ylim=list(NULL,c(-20,20),c(-25,40),NULL),
       graphs.per.page=4,
       lty=c("dashed", "dotted", "dotdash", "longdash", "dotted",
             "twodash"),
       col=c("red","blue","green","pink","violet","brown"),
       Title= paste(
           "Factors (year to year growth) using full sample and sub-samples\n",
           "ML estimation with quartimin rotation objective", sep=""),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 43: 
###################################################
#line 481 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(MBandCredit),                ytoypc(explained(c4withML)),
       ytoypc(explained(c4withMLbefore90)), ytoypc(explained(c4withMLbefore95)),
       ytoypc(explained(c4withMLafter95)),  ytoypc(explained(c4withMLafter00)),
       ytoypc(explained(c4withML90to00)), series=1:5, graphs.per.page=5,
       ylab=c("currency", "personal cheq.", "NonbankCheq",
              "N-P demand & notice", "N-P term"),
       ylim=list(NULL,NULL,c(-70,70),NULL,c(-70,70)),
       lty=c("solid", "dashed", "dotted", "dotdash", "longdash", "dotted",
             "twodash"),
       col=c("black", "red","blue","green","pink","violet","brown"),
       Title= paste("Explained money indicators 1-5 (year to year growth)\n",
               "using 4 factors, full sample and sub-samples", sep=""),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 44: 
###################################################
#line 501 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(MBandCredit), ytoypc(explained(c4withML)),
       ytoypc(explained(c4withMLbefore90)), ytoypc(explained(c4withMLbefore95)),
       ytoypc(explained(c4withMLafter95)),  ytoypc(explained(c4withMLafter00)),
       ytoypc(explained(c4withML90to00)), series=6:10, graphs.per.page=5,
       ylab=c("","","","","",
              "Investment","Consumer Credit", "Residential Mortgage",
              "Short Term Business Credit", "Other Business Credit"),
       lty=c("solid", "dashed", "dotted", "dotdash", "longdash", "dotted",
             "twodash"),
       col=c("black", "red","blue","green","pink","violet","brown"),
       Title= paste("Explained money indicators 6-10 (year to year growth)\n",
               "using 4 factors, full sample and sub-samples", sep=""),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


###################################################
### chunk number 45: 
###################################################
#line 524 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
M1   <-  tfwindow(M1total, start=c(1981,11), end=c(2004,11)) * scale
seriesNames(M1) <- "Real per Capita M1"

z <-  tframed(MB2001 + MB486 + MB487p + MB452 + MB452adj + MB472 + NonbankCheq)

M1p   <-  tfwindow(z, start=c(1981,11), end=c(2004,11)) * scale
seriesNames(M1p) <- "Real per Capita M1+"

M2pp <-  tfwindow(M1total
                 + MB472 + MB473 + MB452 + MB453 + MB454
                 + NonbankCheq + NonbankNonCheq + NonbankTerm +
                 + MB2046 + MB2047 + MB2048
                 + MB2057 + MB2058, start=c(1981,11), end=c(2004,11))* scale

seriesNames(M2pp) <- "Real per Capita M2++"


###################################################
### chunk number 46: 
###################################################
#line 543 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
f <- tframed(factors(c4withML)[,1:2], tf=tframe(factors(c4withML)))
mnF <- colMeans(f)
mnM <- colMeans(cbind(M1p, M2pp))
f <- sweep(f, 2, mnM/mnF, "*")


###################################################
### chunk number 47: 
###################################################
#line 553 "d:/Rcompile/CRANpkg/local/2.12/tsfa/inst/doc/Guide.Stex"
tfplot(ytoypc(f), ytoypc(cbind(M1, M2pp)), graphs.per.page=2,
       lty=c("dashed", "solid"),
       col=c("red","black"),
       Title=
   paste("(year to year growth) M1+ and M2++ (solid) and scaled Bartlett Predictors\n",
           "computed using ordinary ML parameters (dashed)", sep=""),
       ylab=c("M1+ vs. factor 1", "M2++ vs. factor 2" ),
       par=list(omi=c(0.1,0.1,0.1,0.1),mar=c(3.1,4.1,0.6,0.1)),
       reset.screen=TRUE)


